#include <amxmodx.inc>
#include <Vexd_Utilities.inc>
#include <engine.inc>
#include <amxmisc.inc>

/*
Set the Overkill_Health cvar to a NEGATIVE number. What this will do is check the health of
the user after he is dead any damage that did over the players default health (100 hp lets say)
then it will be recorded and compared to the negative number. If they did 110 damage to a guy
with a health of 100 hp, then -10 would the would be the resulting health. If they did 120
damage then -20 would be the resulting health and so on.
*/


public plugin_init() {
    register_plugin("Amx Overkill Afterkill","1.0","Votorx")
    register_cvar("Overkill_Health","-20")
    register_cvar("Play_Sound","1")
    register_event("DeathMsg","DeployImage", "a")
    register_event("RoundTime", "new_round", "bc")
    return PLUGIN_CONTINUE
}

new iSlot, iEnt[32]

public plugin_precache(){
    precache_model("models/Overkill.spr")
    return PLUGIN_CONTINUE
}

public DeployImage(){
	new klr = read_data(1), kld = read_data(2), Float:iHealth, Float:fOrigin[3]
	
	if ( !klr || klr == kld){ 
	return PLUGIN_CONTINUE 
	}
	iHealth = entity_get_float(kld, EV_FL_health)
	if(iHealth <= (get_cvar_num("Overkill_Health")))
	{
		entity_get_vector(kld, EV_VEC_origin, fOrigin)
		iEnt[iSlot] = CreateEntity("info_target")
		entity_set_model(iEnt[iSlot],"models/Overkill.spr")
		entity_set_origin(iEnt[iSlot], fOrigin)
		iSlot++
	}
	return PLUGIN_CONTINUE
} 

public new_round() {
	if ( floatround(get_cvar_float("mp_roundtime") * 60.0) != read_data(1) ) return
	new iThrough
	while(iThrough <= iSlot){
		remove_entity(iEnt[iThrough])
		iThrough++
	}
	iSlot = 0
}